  DEF SCRIPT Script {

  directOutput TRUE
  field SFNode self USE SCRIPT


  field MFString keys IS keys
  field MFString values IS values
  field MFString params IS params
  field SFString args IS args

  field SFNode root USE ROOT
  field MFNode children IS children

  field SFVec3f position IS translation

  field SFInt32 type IS type
  field SFInt32 level IS level
  field SFInt32 mode IS mode
  field SFString style IS style
  field SFString class IS class
  field SFString category IS category
  field SFString meta IS meta


  field SFInt32 slidetype IS slidetype

  ##field SFNode bg USE BG  ## must be done dynamically
  ##field SFNode view USE VIEW  ## must be done dynamically

  exposedField SFVec3f scale IS scale
  exposedField SFColor textColor IS textcolor

  field SFFloat x 1.5
  field SFFloat y 1
  field SFFloat z 1

  field SFNode plane USE PLANE  ## must be done dynamically
  field SFNode text USE TEXT  ## must be done dynamically

  field SFNode mat USE MAT
  field SFNode bmat USE BMAT

  field   SFNode slides      USE SWITCH
  field   MFNode showeffects IS  showeffects
  field   MFNode hideeffects IS  hideeffects
    
  eventIn SFTime next IS next
  eventIn SFTime prev IS prev
    
  field   SFNode showTimeSensor USE SHOWTIMER
  eventIn SFBool showTimer

  field   SFNode hideTimeSensor USE HIDETIMER
  eventIn SFBool hideTimer

  field   SFInt32 nextSlide 0 
  
  field   SFNode hud USE FRONT
  field   SFNode face USE FACE

  field   SFInt32 withHUD IS withHUD

  field   SFNode  lbutton USE LBUTTON
  field   SFNode  rbutton USE RBUTTON

  field   SFNode  left USE LEFT
  field   SFNode  right USE RIGHT

  url "javascript:
  #@include scripts/assoc.js
  #@include scripts/util.js
  #@include scripts/show.js
  #@include scripts/style.js

  function initialize() {
    parse_args();
    parse_params();

    //print_keys();
    style();
    //test();
    if (withHUD > 0) {
       Browser.addRoute(rbutton,'touchTime',self,'next');
       Browser.addRoute(lbutton,'touchTime',self,'prev');
       Browser.addRoute(showTimeSensor,'isActive',self,'showTimer');
       Browser.addRoute(hideTimeSensor,'isActive',self,'hideTimer');
       }
  }
  function shutdown() {
    if (withHUD > 0) {
       Browser.deleteRoute(rbutton,'touchTime',self,'next');
       Browser.deleteRoute(lbutton,'touchTime',self,'prev');
       Browser.deleteRoute(showTimeSensor,'isActive',self,'showTimer');
       Browser.deleteRoute(hideTimeSensor,'isActive',self,'hideTimer');
       }
  }
  "
 }
